-- A few globals
BINDING_HEADER_M1 = "M1 Bar"
BINDING_NAME_M1ACTIONBUTTON1  = "G1";
BINDING_NAME_M1ACTIONBUTTON2  = "G2";
BINDING_NAME_M1ACTIONBUTTON3  = "G3";
BINDING_NAME_M1ACTIONBUTTON4  = "G4";
BINDING_NAME_M1ACTIONBUTTON5  = "G5";
BINDING_NAME_M1ACTIONBUTTON6  = "G6";
BINDING_NAME_M1ACTIONBUTTON7  = "G7";
BINDING_NAME_M1ACTIONBUTTON8  = "G8";
BINDING_NAME_M1ACTIONBUTTON9  = "G9";
BINDING_NAME_M1ACTIONBUTTON10  = "G10";
BINDING_NAME_M1ACTIONBUTTON11  = "G11";
BINDING_NAME_M1ACTIONBUTTON12  = "G12";
BINDING_NAME_M1ACTIONBUTTON13  = "G13";
BINDING_NAME_M1ACTIONBUTTON14  = "G14";
BINDING_NAME_M1ACTIONBUTTON15  = "G15";
BINDING_NAME_M1ACTIONBUTTON16  = "G16";
BINDING_NAME_M1ACTIONBUTTON17  = "G17";
BINDING_NAME_M1ACTIONBUTTON18  = "G18";

BINDING_HEADER_M2 = "M2 Bar"
BINDING_NAME_M2ACTIONBUTTON1  = "G1";
BINDING_NAME_M2ACTIONBUTTON2  = "G2";
BINDING_NAME_M2ACTIONBUTTON3  = "G3";
BINDING_NAME_M2ACTIONBUTTON4  = "G4";
BINDING_NAME_M2ACTIONBUTTON5  = "G5";
BINDING_NAME_M2ACTIONBUTTON6  = "G6";
BINDING_NAME_M2ACTIONBUTTON7  = "G7";
BINDING_NAME_M2ACTIONBUTTON8  = "G8";
BINDING_NAME_M2ACTIONBUTTON9  = "G9";
BINDING_NAME_M2ACTIONBUTTON10  = "G10";
BINDING_NAME_M2ACTIONBUTTON11  = "G11";
BINDING_NAME_M2ACTIONBUTTON12  = "G12";
BINDING_NAME_M2ACTIONBUTTON13  = "G13";
BINDING_NAME_M2ACTIONBUTTON14  = "G14";
BINDING_NAME_M2ACTIONBUTTON15  = "G15";
BINDING_NAME_M2ACTIONBUTTON16  = "G16";
BINDING_NAME_M2ACTIONBUTTON17  = "G17";
BINDING_NAME_M2ACTIONBUTTON18  = "G18";

BINDING_HEADER_M3 = "M3 Bar"
BINDING_NAME_M3ACTIONBUTTON1  = "G1";
BINDING_NAME_M3ACTIONBUTTON2  = "G2";
BINDING_NAME_M3ACTIONBUTTON3  = "G3";
BINDING_NAME_M3ACTIONBUTTON4  = "G4";
BINDING_NAME_M3ACTIONBUTTON5  = "G5";
BINDING_NAME_M3ACTIONBUTTON6  = "G6";
BINDING_NAME_M3ACTIONBUTTON7  = "G7";
BINDING_NAME_M3ACTIONBUTTON8  = "G8";
BINDING_NAME_M3ACTIONBUTTON9  = "G9";
BINDING_NAME_M3ACTIONBUTTON10  = "G10";
BINDING_NAME_M3ACTIONBUTTON11  = "G11";
BINDING_NAME_M3ACTIONBUTTON12  = "G12";
BINDING_NAME_M3ACTIONBUTTON13  = "G13";
BINDING_NAME_M3ACTIONBUTTON14  = "G14";
BINDING_NAME_M3ACTIONBUTTON15  = "G15";
BINDING_NAME_M3ACTIONBUTTON16  = "G16";
BINDING_NAME_M3ACTIONBUTTON17  = "G17";
BINDING_NAME_M3ACTIONBUTTON18  = "G18";


	  G15Locked= 1;
local button_scale=0.5;
local bound=0;

function G15BarButtonDown(section, id)
	local button = getglobal(section.."BarButton"..id);
	if ( button:GetButtonState() == "NORMAL" ) then
		button:SetButtonState("PUSHED");
	end
end

function G15BarButtonUp(section, id)
	local button = getglobal(section.."BarButton"..id);
	if ( button:GetButtonState() == "PUSHED" ) then
		button:SetButtonState("NORMAL");
		UseAction(G15BarButton_GetID(button), 0);
		if ( IsCurrentAction(G15BarButton_GetID(button)) ) then
			button:SetChecked(1);
		else
			button:SetChecked(0);
		end
	end
end

function G15BarButton_OnLoad()

	this.showgrid = 1;
	this.flashing = 0;
	this.flashtime = 0;
	G15BarButton_Update();
	this:RegisterForDrag("LeftButton", "RightButton");
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("ACTIONBAR_SHOWGRID");
	this:RegisterEvent("ACTIONBAR_HIDEGRID");
	this:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
	this:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
	this:RegisterEvent("ACTIONBAR_UPDATE_STATE");
	this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
	this:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_AURASTATE");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("CRAFT_SHOW");
	this:RegisterEvent("CRAFT_CLOSE");
	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("TRADE_SKILL_CLOSE");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("UNIT_COMBO_POINTS");
	this:RegisterEvent("START_AUTOREPEAT_SPELL");
	this:RegisterEvent("STOP_AUTOREPEAT_SPELL");

	SlashCmdList["ABCMD"] = G15BarButton_Cmd;
    	SLASH_ABCMD1 = "/g15bar";


end


function G15BarButton_Cmd(msg)
    msg = string.lower(msg);

-- default message if no parameters are passed    
    if ( string.len(msg) == 0 ) then
		DEFAULT_CHAT_FRAME:AddMessage("G15Bar usage:" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar scale=<scale> -> sets scale (2-20, 10=100%)" , 0.4, 0.4, 1.0);	
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar lock -> lock the window from movement" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar unlock -> unlocks the window, allowing it to be moved" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar reset -> reset the window to the center" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar showgrid -> shows buttongrid of unpopulated buttons" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar hidegrid -> hides buttongrid of unpopulated buttons" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar showlabel -> shows the M-Bar labels" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar hidelabel -> hides the M-Bar labels" , 0.4, 0.4, 1.0);
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar bind -> links all of the M-Bars together to allow them to be dragged together as one object" , 0.4, 0.4, 1.0);	
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar unbind -> breaks apart the M-Bars, allowing each one to be moved seperatly" , 0.4, 0.4, 1.0);		
		DEFAULT_CHAT_FRAME:AddMessage("/G15bar numbars=<num> -> sets the number of visable M-Bars. Note: bars that are not visable are still usable!" , 0.4, 0.4, 1.0);
		return
    end 

-- scaling
    if (string.sub(msg, 1, 5) == "scale") then
		local scale = tonumber(string.sub(msg, 7));
		if(not scale or scale < 2 or scale > 20) then
			DEFAULT_CHAT_FRAME:AddMessage("G15bar button scale must be from 2 to 20. 2=20%, 10=100%, 15=150%, 20=200%");
			return;
		end
		button_scale=scale/10;
        G15BarButton_Scale(button_scale);
        --reset the UI position
        M1GrabBar:ClearAllPoints();
		M1GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
        M2GrabBar:ClearAllPoints();
		M2GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
        M3GrabBar:ClearAllPoints();
		M3GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
		DEFAULT_CHAT_FRAME:AddMessage("G15Bar scaled. New Size="..scale.."." , 0.4, 0.4, 1.0);
		G15Scale=button_scale; 
		return;
    end
    
--reset the UI position
    if (string.sub(msg, 1, 5) == "reset") then
        M1GrabBar:ClearAllPoints();
		M1GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
        M2GrabBar:ClearAllPoints();
		M2GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
        M3GrabBar:ClearAllPoints();
		M3GrabBar:SetPoint("TOPLEFT","UIParent","CENTER",0,0);
			if (G15Bound ~= nil) then
			    if (G15Bound  == 1) then
					M2BarButton1:ClearAllPoints();
					M3BarButton1:ClearAllPoints();
					M2BarButton2:ClearAllPoints();
					M3BarButton2:ClearAllPoints();
			        M3GrabBar:ClearAllPoints();
			        M2GrabBar:ClearAllPoints();
					M2GrabBar:SetPoint("BOTTOM", M2BarButton2, "TOP", 0, 9);
					M2BarButton2:SetPoint("LEFT", M2BarButton1, "RIGHT", 3, 0);
					M3GrabBar:SetPoint("BOTTOM", M3BarButton2, "TOP", 0, 9);
					M3BarButton2:SetPoint("LEFT", M3BarButton1, "RIGHT", 3, 0);
			        M2BarButton1:SetPoint("LEFT", M1BarButton3, "RIGHT", 12, 0);
			        M3BarButton1:SetPoint("LEFT", M2BarButton3, "RIGHT", 12, 0);
				end
			    bound = G15Bound;
			end
		DEFAULT_CHAT_FRAME:AddMessage("G15Bar reset. New position=Center.", 0.4, 0.4, 1.0);
		return;
    end
    
 	if (string.sub(msg, 1, 4) == "lock") then
	      G15Locked = 1;
		  if (G15ShowLabel == 0) then
			  M1GrabBar:Hide();
	 	      M2GrabBar:Hide();
	      	  M3GrabBar:Hide();
	    	end
	       return
    end

 	if (string.sub(msg, 1, 6) == "unlock") then
 			G15Locked = 0;
 	      	if (G15Bound ~= nil) then
			    if (G15Bound  == 1) then
					M2BarButton1:ClearAllPoints();
					M3BarButton1:ClearAllPoints();
					M2BarButton2:ClearAllPoints();
					M3BarButton2:ClearAllPoints();
			        M3GrabBar:ClearAllPoints();
			        M2GrabBar:ClearAllPoints();
					M2GrabBar:SetPoint("BOTTOM", M2BarButton2, "TOP", 0, 9);
					M2BarButton2:SetPoint("LEFT", M2BarButton1, "RIGHT", 3, 0);
					M3GrabBar:SetPoint("BOTTOM", M3BarButton2, "TOP", 0, 9);
					M3BarButton2:SetPoint("LEFT", M3BarButton1, "RIGHT", 3, 0);
			        M2BarButton1:SetPoint("LEFT", M1BarButton3, "RIGHT", 12, 0);
			        M3BarButton1:SetPoint("LEFT", M2BarButton3, "RIGHT", 12, 0);
				end
			    bound = G15Bound;
			end
 	      M1GrabBar:Show();
 	      M2GrabBar:Show();
 	      M3GrabBar:Show();
 	      return
	end
	
 	if (string.sub(msg, 1, 4) == "bind") then
		M2BarButton1:ClearAllPoints();
		M3BarButton1:ClearAllPoints();
		M2BarButton2:ClearAllPoints();
		M3BarButton2:ClearAllPoints();
        M3GrabBar:ClearAllPoints();
        M2GrabBar:ClearAllPoints();
		M2GrabBar:SetPoint("BOTTOM", M2BarButton2, "TOP", 0, 9);
		M2BarButton2:SetPoint("LEFT", M2BarButton1, "RIGHT", 3, 0);
		M3GrabBar:SetPoint("BOTTOM", M3BarButton2, "TOP", 0, 9);
		M3BarButton2:SetPoint("LEFT", M3BarButton1, "RIGHT", 3, 0);
        M2BarButton1:SetPoint("LEFT", M1BarButton3, "RIGHT", 12, 0);
        M3BarButton1:SetPoint("LEFT", M2BarButton3, "RIGHT", 12, 0);
		bound = 1;
		G15Bound = 1;
	    return
    end

 	if (string.sub(msg, 1, 6) == "unbind") then
		M2BarButton1:ClearAllPoints();
		M3BarButton1:ClearAllPoints();
		M2BarButton2:ClearAllPoints();
		M3BarButton2:ClearAllPoints();
        M3GrabBar:ClearAllPoints();
        M2GrabBar:ClearAllPoints();
		M2BarButton2:SetPoint("TOP", M2GrabBar, "BOTTOM", 0, -9);
		M3BarButton2:SetPoint("TOP", M3GrabBar, "BOTTOM", 0, -9);
        M2BarButton1:SetPoint("RIGHT", M2BarButton2, "LEFT", -3, 0);
        M3BarButton1:SetPoint("RIGHT", M3BarButton2, "LEFT", -3, 0);
		bound = 0;
	    G15Bound = 0;
	    return
	end
	
	if (string.sub(msg, 1, 9) == "showlabel") then
 	      M1GrabBar:Show();
 	      M2GrabBar:Show();
 	      M3GrabBar:Show();
	    G15ShowLabel = 1;
	    return
	end
	
	if (string.sub(msg, 1, 9) == "hidelabel") then
		  if (G15Locked == 1) then
			  M1GrabBar:Hide();
	 	      M2GrabBar:Hide();
	      	  M3GrabBar:Hide();
	       end
	    G15ShowLabel = 0;
	    return
	end
	
	if (string.sub(msg, 1, 8) == "showgrid") then
		for i=1,3 do 
			for j=1,18 do
			  	local button = getglobal("M"..i.."BarButton"..j); 
				button.showgrid = 1;
				getglobal(button:GetName().."NormalTexture"):SetVertexColor(1.0, 1.0, 1.0);
				button:Show();
			end
		end
		G15ShowGrid = 1;     
	    return
	end
	
	if (string.sub(msg, 1, 8) == "hidegrid") then
		for i=1,3 do 
			for j=1,18 do 
			  	local button = getglobal("M"..i.."BarButton"..j);
				button.showgrid = 0;
				if ( button.showgrid == 0 and not HasAction(G15BarButton_GetID(button)) ) then
					button:Hide();
				end
			end
		end
		G15ShowGrid = 0;
	    return
	end
	
	if (string.sub(msg, 1, 7) == "numbars") then
		local num = tonumber(string.sub(msg, 9));
		if(not num or num < 0 or num > 3) then
			DEFAULT_CHAT_FRAME:AddMessage("The number of visable bars must be from 0 to 3.");
			return;
		end
		if(num == 0) then
			M1Bar:Hide();
			M2Bar:Hide();
			M3Bar:Hide();
		elseif(num == 1) then
			M1Bar:Show();
			M2Bar:Hide();
			M3Bar:Hide();
		elseif(num == 2) then
			M1Bar:Show();
			M2Bar:Show();
			M3Bar:Hide();
		elseif(num == 3) then
			M1Bar:Show();
			M2Bar:Show();
			M3Bar:Show();
		G15NumBars = num;
		end	
	end
end                             

function G15BarButton_Init()
	if (G15Scale ~= nil) then
		button_scale = G15Scale;
		G15BarButton_Scale(button_scale);
	end
	
	if (G15Bound ~= nil) then
	    if (G15Bound  == 1) then
			M2BarButton1:ClearAllPoints();
			M3BarButton1:ClearAllPoints();
			M2BarButton2:ClearAllPoints();
			M3BarButton2:ClearAllPoints();
	        M3GrabBar:ClearAllPoints();
	        M2GrabBar:ClearAllPoints();
			M2GrabBar:SetPoint("BOTTOM", M2BarButton2, "TOP", 0, 9);
			M2BarButton2:SetPoint("LEFT", M2BarButton1, "RIGHT", 3, 0);
			M3GrabBar:SetPoint("BOTTOM", M3BarButton2, "TOP", 0, 9);
			M3BarButton2:SetPoint("LEFT", M3BarButton1, "RIGHT", 3, 0);
	        M2BarButton1:SetPoint("LEFT", M1BarButton3, "RIGHT", 12, 0);
	        M3BarButton1:SetPoint("LEFT", M2BarButton3, "RIGHT", 12, 0);
		end
	    bound = G15Bound;
	end
	
	if (G15ShowLabel ~= nil) then
	    if (G15ShowLabel  == 1) then
 	      M1GrabBar:Show();
 	      M2GrabBar:Show();
 	      M3GrabBar:Show();
		end
	end
	
	if (G15ShowGrid ~= nil) then
	    if (G15ShowGrid  == 0) then
 	      G15BarButton_HideGrid();
		end
	end
	
	if (G15NumFrames == nil) then
		G15NumFrames = 3;
	end	
	
	if(G15NumFrames == 0) then
		M1Bar:Hide();
		M2Bar:Hide();
		M3Bar:Hide();
	elseif(G15NumFrames == 1) then
		M1Bar:Show();
		M2Bar:Hide();
		M3Bar:Hide();
	elseif(G15NumFrames == 2) then
		M1Bar:Show();
		M2Bar:Show();
		M3Bar:Hide();
	elseif(G15NumFrames == 3) then
		M1Bar:Show();
		M2Bar:Show();
		M3Bar:Show();
	end
end


function G15BarButton_Update()
	-- Determine whether or not the button should be flashing or not since the button may have missed the enter combat event
	local buttonID = G15BarButton_GetID(this);
	if ( IsAttackAction(buttonID) and IsCurrentAction(buttonID) ) then
		IN_ATTACK_MODE = 1;
	else
		IN_ATTACK_MODE = nil;
	end
	IN_AUTOREPEAT_MODE = IsAutoRepeatAction(buttonID);
	
	local icon = getglobal(this:GetName().."Icon");
	local buttonCooldown = getglobal(this:GetName().."Cooldown");
	local texture = GetActionTexture(G15BarButton_GetID(this));
	if ( texture ) then
		icon:SetTexture(texture);
		icon:Show();
		this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
	else
		icon:Hide();
		buttonCooldown:Hide();
		this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
	end
	G15BarButton_UpdateCount();
	if ( HasAction(G15BarButton_GetID(this)) ) then
		this:Show();
		G15BarButton_UpdateUsable();
		G15BarButton_UpdateCooldown();
	elseif ( this.showgrid == 0 ) then
		this:Hide();
	else
		getglobal(this:GetName().."Cooldown"):Hide();
	end
	if ( IN_ATTACK_MODE or IN_AUTOREPEAT_MODE ) then
		G15BarButton_StartFlash();
	else
		G15BarButton_StopFlash();
	end
	if ( GameTooltip:IsOwned(this) ) then
		G15BarButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end

	-- Update Macro Text
	local macroName = getglobal(this:GetName().."Name");
	macroName:SetText(GetActionText(G15BarButton_GetID(this)));


	G15BarButton_Scale(button_scale);

end

function G15BarButton_Scale(factor)
	if(G15Bar:GetScale() ~= factor) then
		this.needsUpdate = 1;
	end
	if(this.needsUpdate) then
		G15Bar:SetScale(factor);
		this.needsUpdate = nil;
	end
end

function G15BarButton_ShowGrid()
	this.showgrid = 1;
	getglobal(this:GetName().."NormalTexture"):SetVertexColor(1.0, 1.0, 1.0);
	this:Show();
end

function G15BarButton_HideGrid()
	this.showgrid = 0;
	if ( this.showgrid == 0 and not HasAction(G15BarButton_GetID(this)) ) then
		this:Hide();
	end
end

function G15BarButton_UpdateState()
	if ( IsCurrentAction(G15BarButton_GetID(this)) or IsAutoRepeatAction(G15BarButton_GetID(this)) ) then
		this:SetChecked(1);
	else
		this:SetChecked(0);
	end
end

function G15BarButton_UpdateUsable()
	local icon = getglobal(this:GetName().."Icon");
	local normalTexture = getglobal(this:GetName().."NormalTexture");
	local isUsable, notEnoughMana = IsUsableAction(G15BarButton_GetID(this));
	if ( isUsable ) then
		icon:SetVertexColor(1.0, 1.0, 1.0);
		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.5, 0.5, 1.0);
		normalTexture:SetVertexColor(0.5, 0.5, 1.0);
	else
		icon:SetVertexColor(0.4, 0.4, 0.4);
		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	end
end

function G15BarButton_UpdateCount()
	local text = getglobal(this:GetName().."Count");
	local count = GetActionCount(G15BarButton_GetID(this));
	if ( count > 1 ) then
		text:SetText(count);
	else
		text:SetText("");
	end
end

function G15BarButton_UpdateCooldown()
	local cooldown = getglobal(this:GetName().."Cooldown");
	local start, duration, enable = GetActionCooldown(G15BarButton_GetID(this));
	CooldownFrame_SetTimer(cooldown, start, duration, enable);
end

function G15BarButton_OnEvent(event)
	if ( event == "VARIABLES_LOADED" ) then
		G15BarButton_Init();
	end
	if ( event == "ADDON_LOADED" ) then
		G15BarButton_Init();
	end
	if ( event == "ACTIONBAR_SLOT_CHANGED" ) then
		if ( arg1 == -1 or arg1 == G15BarButton_GetID(this) ) then
			G15BarButton_Update();
		end
		return;
	end
	if ( event == "PLAYER_AURAS_CHANGED") then
		G15BarButton_Update();
		G15BarButton_UpdateState();
		return;
	end
	if ( event == "ACTIONBAR_SHOWGRID" ) then
		G15BarButton_ShowGrid();
		return;
	end
	if ( event == "ACTIONBAR_HIDEGRID" and G15ShowGrid == 0) then
		G15BarButton_HideGrid();
		return;
	end

	-- All event handlers below this line MUST only be valid when the button is visible
	if ( not this:IsVisible() ) then
		return;
	end

	if ( event == "PLAYER_TARGET_CHANGED" ) then
		G15BarButton_UpdateUsable();
		return;
	end
	if ( event == "UNIT_AURASTATE" ) then
		if ( arg1 == "player" or arg1 == "target" ) then
			G15BarButton_UpdateUsable();
		end
		return;
	end
	if ( event == "UNIT_INVENTORY_CHANGED" ) then
		if ( arg1 == "player" ) then
			G15BarButton_Update();
		end
		return;
	end
	if ( event == "ACTIONBAR_UPDATE_STATE" ) then
		G15BarButton_UpdateState();
		return;
	end
	if ( event == "ACTIONBAR_UPDATE_USABLE" ) then
		G15BarButton_UpdateUsable();
		return;
	end
	if ( event == "ACTIONBAR_UPDATE_COOLDOWN" ) then
		G15BarButton_UpdateCooldown();
		return;
	end
	if ( event == "CRAFT_SHOW" or event == "CRAFT_CLOSE" or event == "TRADE_SKILL_SHOW" or event == "TRADE_SKILL_CLOSE" ) then
		G15BarButton_UpdateState();
		return;
	end
	if ( arg1 == "player" and (event == "UNIT_HEALTH" or event == "UNIT_MANA" or event == "UNIT_RAGE" or event == "UNIT_FOCUS" or event == "UNIT_ENERGY") ) then
		G15BarButton_UpdateUsable();
		return;
	end
	if ( event == "PLAYER_ENTER_COMBAT" ) then
		IN_ATTACK_MODE = 1;
		if ( IsAttackAction(G15BarButton_GetID(this)) ) then
			G15BarButton_StartFlash();
		end
		return;
	end
	if ( event == "PLAYER_LEAVE_COMBAT" ) then
		IN_ATTACK_MODE = 0;
		if ( IsAttackAction(G15BarButton_GetID(this)) ) then
			G15BarButton_StopFlash();
		end
		return;
	end
	if ( (event == "UNIT_COMBO_POINTS") and (arg1 == "player") ) then
		G15BarButton_UpdateUsable();
		return;
	end
	if ( event == "START_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = 1;
		if ( IsAutoRepeatAction(G15BarButton_GetID(this)) ) then
			G15BarButton_StartFlash();
		end
		return;
	end
	if ( event == "STOP_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = nil;
		if ( G15BarButton_IsFlashing() and not IsAttackAction(G15BarButton_GetID(this)) ) then
			G15BarButton_StopFlash();
		end
		return;
	end
end

function G15BarButton_SetTooltip()
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	if ( GameTooltip:SetAction(G15BarButton_GetID(this)) ) then
		this.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		this.updateTooltip = nil;
	end
end

function G15BarButton_OnUpdate(elapsed)
	if ( G15BarButton_IsFlashing() ) then
		this.flashtime = this.flashtime - elapsed;
		if ( this.flashtime <= 0 ) then
			local overtime = -this.flashtime;
			if ( overtime >= ATTACK_BUTTON_FLASH_TIME ) then
				overtime = 0;
			end
			this.flashtime = ATTACK_BUTTON_FLASH_TIME - overtime;

			local flashTexture = getglobal(this:GetName().."Flash");
			if ( flashTexture:IsVisible() ) then
				flashTexture:Hide();
			else
				flashTexture:Show();
			end
		end
	end

	if ( not this.updateTooltip ) then
		return;
	end

	this.updateTooltip = this.updateTooltip - elapsed;
	if ( this.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(this) ) then
		G15BarButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end
end

function G15BarButton_GetID(button)
	if ( button == nil ) then
		message("nil button passed into G15BarButton_GetID(), contact Fastjack");
		return 0;
	end
	return (button:GetID())
end

function G15BarButton_StartFlash()
	this.flashing = 1;
	this.flashtime = 0;
	G15BarButton_UpdateState();
end

function G15BarButton_StopFlash()
	this.flashing = 0;
	getglobal(this:GetName().."Flash"):Hide();
	G15BarButton_UpdateState();
end

function G15BarButton_IsFlashing()
	if ( this.flashing == 1 ) then
		return 1;
	else
		return nil;
	end
end
